package mmkurssit;

import java.util.List;

/**
 * CRC sisällöt tähän
 * @author aichi
 * @version 26 Feb 2025
 *
 */
public class MMKurssit {

    private final Kurssit kurssit = new Kurssit();
    private final Tapaamiset tapaamiset = new Tapaamiset();
    
//==================================================================

    
    /**
     * Lisätään uusi kurssi
     * @param esimk lisättävä kurssi
     * @throws SailoException jos lisääminen ei onnistu
     */
    public void lisaa(Kurssi esimk) throws SailoException {
        kurssit.lisaa(esimk);
    }
    
    
    
    /**
     * Lisätään uusi tapaaminen
     * @param tap lisättävä tapaaminen
     */
    public void lisaa(Tapaaminen tap) {
        tapaamiset.lisaa(tap);
    }
    
    /**
     * @return kurssien kpl
     */
    public int getKurssienKpl() {
        return kurssit.getKpl();
    }
    
    
    /**
     * @param i kyseisen kurssin indeksi
     * @return pyydetty kurssi kurssit-taulkosta
     */
    public Kurssi annaKurssi(int i) {
        return kurssit.anna(i);
    }
    
    
    /**
     * @param kur kyseinen kurssi
     * @return tapaamiset (laitettuna listaan) jotka liittyvät kyseiseen kurssiin
     */
    public List<Tapaaminen> annaTapaamiset(Kurssi kur){
        return tapaamiset.annaTapaamiset(kur.getID());
    }
    
//===================================================================
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
    
            MMKurssit mmkurssit = new MMKurssit();
            
            Kurssi japani4 = new Kurssi();
            japani4.rekisteroi();
            japani4.tayta();
            
            Kurssi ohjelmointi2 = new Kurssi();
            ohjelmointi2.rekisteroi();
            ohjelmointi2.tayta();
            
            try {
                mmkurssit.lisaa(japani4);
                mmkurssit.lisaa(ohjelmointi2);
                //ohjelma.lisaa(japani4);
                //ohjelma.lisaa(ohjelmointi2);
                //ohjelma.lisaa(japani4);
                //ohjelma.lisaa(ohjelmointi2);//heittää error
            } catch (SailoException e) {
                System.err.println(e.getMessage());
            }
            
            
            for (int i=0; i<mmkurssit.getKurssienKpl(); i++) {
                Kurssi kurssi = mmkurssit.annaKurssi(i);
                kurssi.tulosta(System.out);
            }
            
            
            System.out.println("======================================");
            
            Tapaaminen j4_1 = new Tapaaminen(japani4.getID());
            j4_1.rekisteroi();
            j4_1.tayta();
            //j4_1.tulosta(System.out);
            Tapaaminen ohj2_1 = new Tapaaminen(ohjelmointi2.getID());
            ohj2_1.rekisteroi();
            ohj2_1.tayta();
            Tapaaminen j4_2 = new Tapaaminen(japani4.getID());
            j4_2.rekisteroi();
            j4_2.tayta();
            
            mmkurssit.lisaa(j4_1);
            mmkurssit.lisaa(ohj2_1);
            mmkurssit.lisaa(j4_2);
            
            List<Tapaaminen> j4_tap = mmkurssit.annaTapaamiset(japani4);
            for(Tapaaminen tap : j4_tap) {
                tap.tulosta(System.out);
            }
    
    }

}
