package mmkurssit;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * Tietorakenne (tällä kerralla taulukko), jossa säilytetään tapaamiset alkioina.
 * @author aichi
 * @version 25 Feb 2025
 *
 */
public class Tapaamiset {

    private Collection<Tapaaminen> alkiot = new ArrayList<Tapaaminen>();
    
//======================================================
    
    
    /** Alustaminen */
    public Tapaamiset() {
        //
    }
    
    /** 
     *@param tap lisattava tapaaminen 
     */
    void lisaa(Tapaaminen tap) {
        alkiot.add(tap);
        
    }
    
    
    /**
     * @param kurssiID kyseisen kurssin ID
     * @return Lisa, jossa on tapaamisia, jonka kID on sama kuin parametriksi annettu kurssiID
     * @example
     * <pre name="test">
     *  //TODO: testin kirjoittaminen
     * </pre>
     */
    public List<Tapaaminen> annaTapaamiset(int kurssiID) {
        
        List<Tapaaminen> loydetyt = new ArrayList<Tapaaminen>();
        for (Tapaaminen tap : alkiot) {
            if (tap.getkID() == kurssiID) loydetyt.add(tap);
        }
        return loydetyt;
    }

    
//=======================================================

    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        
        Tapaamiset tapaamiset = new Tapaamiset();
        
        Tapaaminen j4_1 = new Tapaaminen(1);
        j4_1.rekisteroi();
        j4_1.tayta();
        
        Tapaaminen ohj2_1 = new Tapaaminen(2);
        ohj2_1.rekisteroi();
        ohj2_1.tayta();
        
        Tapaaminen j4_2 = new Tapaaminen(1);
        j4_2.rekisteroi();
        j4_2.tayta();
        
        
        tapaamiset.lisaa(j4_1);
        tapaamiset.lisaa(ohj2_1);
        tapaamiset.lisaa(j4_2);
        
        System.out.println("============ Tapaamiset testi ==================");
        
        
        List<Tapaaminen> tapaamiset1 = tapaamiset.annaTapaamiset(1);
        //"var" käytetään, kun operaattorin oikealla puolella oleva palauttaa selkeästi yksi tyyppi
        // sitten koodin kääntäessä kääntäjä automaattisesti kirjoittaa tyypin nimen var-paikalle.
        // Eli täähän voisi kirjoittaa var tapaamiset2 = ...;
        
        for(Tapaaminen tap : tapaamiset1) {
            System.out.println(tap.getkID()+" ");
            tap.tulosta(System.out);
        }
    
    }


}
